% Analytical solution for Model II: de Groot (2015, JEDC): "Solving asset pricing models with stochastic volatility" 

nu1 = 1/(1-phi_x);
nu2 = -phi_x*(phi_x+phi_z)*(1-phi_z)^2/(phi_z^2-phi_x)/(phi_z-phi_x)/(1-phi_x);
nu3 = -2*phi_z^2/(phi_z-phi_x);
nu4 = phi_z^4/(phi_z^2-phi_x);
for i = 1:5000
  A(i) = (1-gam)*i;
  B(i) = (1-gam)/(1-phi_z)*phi_z*(1-phi_z^i);
  C(i) = 1/2*((1-gam)/(1-phi_z))^2*(i-2*phi_z*(1-phi_z^i)/(1-phi_z)+...
  phi_z^2*(1-phi_z^(2*i))/(2-phi_z^2));
  D(i) = phi_x/2*((1-gam)/(1-phi_z))^2*(nu1+nu2*phi_x^i+nu3*phi_z^(i-1)+...
  nu4*phi_z^(2*(i-1)));
  H(i) = w^2/8*((1-gam)/(1-phi_z))^4*(i*nu1^2+nu2^2*(1-phi_x^(2*i))/(1-phi_x^2)+...
  nu3^2*(1-phi_z^(2*i))/(1-phi_z^2)+nu4^2*(1-phi_z^(4*i))/(1-phi_z^4)+...
  2*nu1*nu2*(1-phi_x^i)/(1-phi_x)+2*nu1*nu3*(1-phi_z^i)/(1-phi_z)+nu1*nu4*(1-phi_z^(2*i))/(1-phi_z^2)+...
  2*nu2*nu3*(1-(phi_z*phi_x)^i)/(1-phi_z*phi_x)+...
  2*nu2*nu4*(1-(phi_z^2*phi_x)^i)/(1-phi_z^2*phi_x)+2*nu3*nu4*(1-phi_z^(3*i))/(1-phi_z^3));
  bb(i) = i*log(beta);
end

f_analytical_de_groot = @(zx) sum(exp(bb+A*z_star+B*(zx(1)-z_star)+C*x_star+D*(zx(2)-x_star)+H));
