% Algorithm options
order = 4;
xw    = gauss_hermite_xw(2*order+1);
x_gh  = xw(:,1)';
w_gh  = xw(:,2)';

nc = order+1;
% az = -0.1;
% bz = 0.1;
% ax = 0.001;
% bx = 0.002;

az = -0.25;
bz = 0.25;
ax = 0;
bx = 4*x_ss;


a = [az;ax];
b = [bz;bx];

Cheb = chebcoef(nc);

U = chebnodes(nc);
X = (U.^(0:nc-1))*Cheb;
XX = prod_complete2(X,X,order);
dXX = sum(XX'*XX,2);

Snow = 1/2*(U'.*(b-a)+a+b);
SG = gridspace(Snow);
nS = size(SG,2);

param = [beta/(1-beta);zeros(14,1)];
for iter = 1:1000
  for i = 1:nS
    Scurrent = SG(:,i);
    zcurrent = Scurrent(1);
    xcurrent = Scurrent(2);
    qc = expect_GARCH(zcurrent,z_star,phi_z,xcurrent,x_star,phi_x1,phi_x2,az,bz,ax,bx,order,x_gh,w_gh,Cheb)*param;
    Y(i) = beta*exp((1-gam)*zcurrent)*(1+qc);
  end
  nparam = XX'./dXX*Y';
  dist = max(abs(nparam-param));
  if dist <1e-8
    break
  else
    param = nparam;
  end
end
disp(dist);
disp(iter);




