function [Jf,Hf,H3f,Jg,Hg,H3g] = derivModel2(F,G,h,order)
  
  n = length(h);
  n2 = n*(n+1)/2;
  n3 = n*(n+1)*(n+2)/6;
  
  Jf = sym(zeros(n,n)); Jg = Jf;
  Hf = []; Hg = []; H3f = []; H3g = [];
  
  c1 = 0; c2 = 0; c3 = 0;

  %derivatives
  if order == 1
    for i = 1:n
      c1 = c1+1;
      Jf(:,c1) = diff(F,h(i));
      Jg(:,c1) = diff(G,h(i));
    end
  elseif order == 1.5
    Hf = sym(zeros(n,n2));
    for i = 1:n
      c1 = c1+1;
      Jf(:,c1) = diff(F,h(i));
      Jg(:,c1) = diff(G,h(i));      
      for j = i:n
        c2 = c2+1;
        Hf(:,c2) = diff(F,h(i),h(j));
      end
    end
  elseif order == 2
    Hf = sym(zeros(n,n2)); Hg = Hf;
    for i = 1:n
      c1 = c1+1;
      Jf(:,c1) = diff(F,h(i));
      Jg(:,c1) = diff(G,h(i));      
      for j = i:n
        c2 = c2+1;
        Hf(:,c2) = diff(F,h(i),h(j));
        Hg(:,c2) = diff(G,h(i),h(j));
      end
    end
  elseif order == 2.5
    Hf = sym(zeros(n,n2));
    H3f = sym(zeros(n,n3));
    for i = 1:n
      c1 = c1+1;
      Jf(:,c1) = diff(F,h(i));
      Jg(:,c1) = diff(G,h(i));      
      for j = i:n
        c2 = c2+1;
        Hf(:,c2) = diff(F,h(i),h(j));
        for l = j:n
          c3 = c3+1;
          H3f(:,c3) = diff(F,h(i),h(j),h(l));
        end
      end
    end
  elseif order == 3
    Hf = sym(zeros(n,n2)); Hg = Hf;
    H3f = sym(zeros(n,n3)); H3g = H3f;
     for i = 1:n
      c1 = c1+1;
      Jf(:,c1) = diff(F,h(i));
      Jg(:,c1) = diff(G,h(i));      
      for j = i:n
        c2 = c2+1;
        Hf(:,c2) = diff(F,h(i),h(j));
        Hg(:,c2) = diff(G,h(i),h(j));
        for l = j:n
          c3 = c3+1;
          H3f(:,c3) = diff(F,h(i),h(j),h(l));
          H3g(:,c3) = diff(G,h(i),h(j),h(l));
        end
      end
    end
  end
end
